﻿Imports System.Threading
Imports System.Drawing.Imaging

Public Class OberflaecheKlasse
    Implements IDisposable
    Private Breite As Integer
    Private Hoehe As Integer
    Private X1 As Integer
    Private Y1 As Integer
    Private X2 As Integer
    Private Y2 As Integer

    Private GrafikErstellen As Thread
    Public Event GrafikAufbauen(Grafik As Bitmap)
    Private Ausfuehren As Boolean
    Private disposedValue As Boolean

    Public Sub GrafikaufbauStarten()
        If Not GrafikErstellen Is Nothing Then
            Throw New Exception("Ich mach doch schon....")
        End If
        Ausfuehren = True
        GrafikErstellen = New Thread(AddressOf OberflaecheZeichnen)
        GrafikErstellen.Start()
    End Sub

    Public Sub GrafikaufbauStoppen()
        Ausfuehren = False
    End Sub

    Public Sub OberflaecheZeichnen()
        While Ausfuehren
            Dim Oberflaeche As Bitmap = New Bitmap(1494, 519)
            'Mit der folgenden Zeile funktioniert es nicht.
            'Dim Oberflaeche As Bitmap = New Bitmap(Seitenbreite, Seitenhoehe)
            Dim OberflaecheObjekt As Graphics = Graphics.FromImage(Oberflaeche)
            OberflaecheObjekt.Clear(Programmfarben(Fensterhintergrundfarbe))
            'Der Arbeitshintergrund wird gezeichnet. Nachdem danach die Arbeitsbereiche
            'gezeichnet werden, bleiben nur noch die Seitenränder sichtbar.
            If Seitenbreite * ZoomFaktor < Oberflaechenbreite Then
                    Zeichenbereich.Links = (Oberflaechenbreite - (Seitenbreite * ZoomFaktor)) / 2
                    Zeichenbereich.Breite = Seitenbreite * ZoomFaktor
                Else
                    Zeichenbereich.Links = 0
                    Zeichenbereich.Breite = Oberflaechenbreite
                End If
                If Seitenhoehe * ZoomFaktor < Oberflaechenhoehe Then
                    Zeichenbereich.Oben = (Oberflaechenhoehe - (Seitenhoehe * ZoomFaktor)) / 2
                    Zeichenbereich.Hoehe = Seitenhoehe * ZoomFaktor
                Else
                    Zeichenbereich.Oben = 0
                    Zeichenbereich.Hoehe = Oberflaechenhoehe
                End If
            Using Ausgefuellt = New SolidBrush(Programmfarben(Seitenraenderfarbe))
                Try
                    OberflaecheObjekt.FillRectangle(Ausgefuellt, New Rectangle(Zeichenbereich.Links, Zeichenbereich.Oben, Zeichenbereich.Breite, Zeichenbereich.Hoehe))
                Catch myerror As Exception
                End Try
            End Using
            RaiseEvent GrafikAufbauen(Oberflaeche)
            Thread.Sleep(10)
        End While
    End Sub

    Protected Overridable Sub Dispose(disposing As Boolean)
        If Not disposedValue Then
            If disposing Then
                ' TODO: Verwalteten Zustand (verwaltete Objekte) bereinigen
            End If

            ' TODO: Nicht verwaltete Ressourcen (nicht verwaltete Objekte) freigeben und Finalizer überschreiben
            ' TODO: Große Felder auf NULL setzen
            disposedValue = True
        End If
    End Sub

    ' ' TODO: Finalizer nur überschreiben, wenn "Dispose(disposing As Boolean)" Code für die Freigabe nicht verwalteter Ressourcen enthält
    ' Protected Overrides Sub Finalize()
    '     ' Ändern Sie diesen Code nicht. Fügen Sie Bereinigungscode in der Methode "Dispose(disposing As Boolean)" ein.
    '     Dispose(disposing:=False)
    '     MyBase.Finalize()
    ' End Sub

    Public Sub Dispose() Implements IDisposable.Dispose
        ' Ändern Sie diesen Code nicht. Fügen Sie Bereinigungscode in der Methode "Dispose(disposing As Boolean)" ein.
        Dispose(disposing:=True)
        GC.SuppressFinalize(Me)
    End Sub
End Class
